<?php
/*
 Plugin Name: Access Exchange
 Plugin URI: http://www.thehiren.com/
 Description: Helps to create additional user in Wordpress and Infusionsoft. 
 Version: 2.7.3
 Author: Hiren Patel
 Author URI: http://www.thehiren.com/
 */
 
/***********************************************************************************************************************************************
define the plugin folder dir
***********************************************************************************************************************************************/ 
define('Accaess_Xchange_PLUGIN_URL', plugin_dir_url(__FILE__));
define('Accaess_Xchange_PLUGIN_DIR', plugin_dir_path(__FILE__));
/***********************************************************************************************************************************************
show all error aspect warnings,deprected and notice errors
***********************************************************************************************************************************************/ 
error_reporting(E_ALL & ~E_DEPRECATED & ~E_NOTICE & ~E_WARNING); 
ini_set('display_errors', 1);
/***********************************************************************************************************************************************
include functions file
***********************************************************************************************************************************************/ 
add_filter('plugins_loaded', 'access_xchange_init' );
function access_xchange_init() {
    require('inc/functions.php');
    /*set orderform http post request handle to this file*/
    if(isset($_REQUEST['save_access_exchage_cfs']) && $_REQUEST['save_access_exchage_cfs'] == "Y")
    {   
        $memburium_install = get_option('access_xchange_memburium_installed');
        if($memburium_install == "NO"){
            include('inc/handler_sdk.php');
        }elseif($memburium_install == "YES"){
            include('inc/handler_memburium.php');
        }else{
            echo "no action selected!!";
        }
        exit;
    }
}
/**********************************************************************************************************************************************
activation hook
**********************************************************************************************************************************************/
register_activation_hook(__FILE__, 'access_xchange_plug_Install');
function access_xchange_plug_Install() 
{
    add_option('access_xchange_activation_redirect');
    add_option('access_xchange_memburium_installed');
    add_option('access_xchange_user_option');
    add_option('access_xchange_is_data');
    add_option('isof_license_key');
    add_option('isof_expire_date');
    add_option('isof_flag');
    global $wpdb;
    $table_name = $wpdb->prefix . "access_xchange_save_http_post";
    $qry = "CREATE TABLE ".$table_name." (
         `id` int(11) NOT NULL AUTO_INCREMENT,
          `querystring` text,
          `status` varchar(255) NOT NULL,
          `reason` varchar(255) NOT NULL,
          `log_date` date NOT NULL,
          `log_timestamp` timestamp NOT NULL DEFAULT current_timestamp() ON UPDATE current_timestamp(),
          PRIMARY KEY(`id`)
        )";
    $wpdb->query($qry);
    update_option('isof_flag', 'Y');
}
/**********************************************************************************************************************************************
after activation redirect to plugin page
**********************************************************************************************************************************************/
add_action('admin_init', 'access_xchange_redirect');
function access_xchange_redirect() {
    if( !is_plugin_active( 'memberium2/memberium2.php' ))
    {
        update_option('access_xchange_memburium_installed', 'NO');
    }
    else{
        update_option('access_xchange_memburium_installed', 'YES');
    }
    if (get_option('access_xchange_activation_redirect')) {
        delete_option('access_xchange_activation_redirect');
        wp_redirect(admin_url( 'admin.php?page=access_exchange'));
    }
}
/**********************************************************************************************************************************************
deactivation hook
**********************************************************************************************************************************************/
register_deactivation_hook(__FILE__, 'access_xchange_deactivation');
function access_xchange_deactivation() 
{
    delete_option('isof_license_key');
    delete_option('isof_expire_date');
    delete_option('isof_flag');
    delete_option('access_xchange_activation_redirect');
    delete_option('access_xchange_memburium_installed');
    delete_option('access_xchange_user_option');
    delete_option('access_xchange_is_data');
    global $wpdb;
    $table_name = $wpdb->prefix . "access_xchange_save_http_post";
    $qry = "DROP TABLE ". $table_name;
    $wpdb->query($qry);
}
/**********************************************************************************************************************************************
uninstall hook
**********************************************************************************************************************************************/
register_uninstall_hook( __FILE__, 'access_xchange_uninstall' );
function access_xchange_uninstall(){
    delete_option('isof_license_key');
    delete_option('isof_expire_date');
    delete_option('isof_flag');
    delete_option('access_xchange_activation_redirect');
    delete_option('access_xchange_memburium_installed');
    delete_option('access_xchange_user_option');
    delete_option('access_xchange_is_data');
    global $wpdb;
    $table_name = $wpdb->prefix . "access_xchange_save_http_post";
    $qry = "DROP TABLE ". $table_name;
    $wpdb->query($qry);
}
/**********************************************************************************************************************************************
if licence key is invalid then dont show plugin update!!
**********************************************************************************************************************************************/
/*$test_license = get_option('isof_flag');
if($test_license == "N"){
    add_filter( 'site_transient_update_plugins', 'filter_plugin_updates' );
}
function filter_plugin_updates( $value ) {
    unset( $value->response['AccessExchange/access_exchange.php'] );
    return $value;
}*/
/**********************************************************************************************************************************************
plugin setting link at backend
**********************************************************************************************************************************************/
$plugin = plugin_basename( __FILE__ );
add_filter( 'plugin_action_links_$plugin', 'access_xchange_settings_link' );
function access_xchange_settings_link( $links ) {
  $settings_link = '<a href="admin.php?page=access_exchange">' . __( 'Settings' ) . '</a>';
  array_push( $links, $settings_link );
  return $links;
}
/***********************************************************************************************************************************************
auto update
***********************************************************************************************************************************************/
add_filter( 'auto_update_plugin', '__return_false' );
 $this_file_access_xchange = __FILE__;
 $update_check_access_xchange = "https://www.hikebranding.com/keys/access_exchange.chk";
 if(is_admin()){
    require_once('gill-updates-access-xchange.php');
 }
 
?>