<?php
class access_xchange_infusion
{
    function __construct()
    {
        add_action('admin_enqueue_scripts', array($this, 'access_xchange_script_style')); /*scripts and styles for plugin admin side*/
        add_action('wp_enqueue_scripts', array($this, 'access_xchange_script_style')); /*scripts and styles for plugin front side*/
        add_action('admin_menu', array($this, 'access_xchange_adminmenu')); /*plugin menu*/
        // add_action('wp_ajax_activate_licensekey_access_xchange', array($this,'activate_licensekey_access_xchange' )); /*licence key validate*/
        // add_action('wp_ajax_nopriv_activate_licensekey_access_xchange', array($this,'activate_licensekey_access_xchange' )); /*licence key validate*/
        add_action('wp_ajax_option_access_xchange', array($this,'option_access_xchange' )); /*save user option*/
        add_action('wp_ajax_nopriv_option_access_xchange', array($this,'option_access_xchange' )); /*save user option*/
        add_action('wp_ajax_is_credantials_access_xchange', array($this,'is_credantials_access_xchange' )); /*save user option*/
        add_action('wp_ajax_nopriv_is_credantials_access_xchange', array($this,'is_credantials_access_xchange' )); /*save user option*/
    }
    /********************************************************Scripts and Style for Plugin********************************************************/
    public static function access_xchange_script_style()
    {    
        wp_enqueue_style('access_xchange_style', Accaess_Xchange_PLUGIN_URL.'css/style.css');  /*css file*/  
        wp_enqueue_script('jquery'); /*include WP jquery*/
        wp_enqueue_script('access_xchange_script', Accaess_Xchange_PLUGIN_URL.'js/script.js');             
        wp_localize_script('access_xchange_script', 'ajax_script', array( 'ajaxurl' => admin_url( 'admin-ajax.php' ) ) ); /*WP AJAX load*/
        wp_localize_script('access_xchange_script', 'access_xchange_plugin_obj', array( 'access_xchange_plugin_url' => Accaess_Xchange_PLUGIN_URL.'img/' ));
        /* plugin url for JS file */
        wp_enqueue_script('access_xchange_datatable_script', Accaess_Xchange_PLUGIN_URL.'js/datatbleView.js');
    }
    /****************************************************************Plugin Menu****************************************************************/
    public static function access_xchange_adminmenu(){
        add_menu_page('Access Exchange', 'Access Exchange', 'manage_options', 'access_exchange', array('access_xchange_infusion','access_xchange_active_licence') , Accaess_Xchange_PLUGIN_URL.'img/menu-icon.png', 4);/*main menu*/
        add_submenu_page( 'access_exchange', 'Setting', 'Setting', 'manage_options', 'access_exchange',array('access_xchange_infusion','access_xchange_active_licence') );/*setting sub menu*/
        /******************************************validate activation key********************************************/
        /*$ae_activation = get_option( 'isof_flag');
        if( $ae_activation == "Y"){*/
            add_submenu_page( 'access_exchange', 'Help', 'Help', 'manage_options', 'access_exchange_help',array('access_xchange_infusion','access_xchange_help'));/*help sub menu*/
            add_submenu_page( 'access_exchange', 'Log', 'Log', 'manage_options', 'access_exchange_log', array('access_xchange_infusion','access_xchange_log') );/*log sub menu*/
        /*}
        else{
            add_submenu_page( null, 'Help', 'Help', 'manage_options', 'access_exchange_help',array('access_xchange_infusion','access_xchange_help') );
            add_submenu_page( null, 'Log', 'Log', 'manage_options', 'access_exchange_log', array('access_xchange_infusion','access_xchange_log') );
        }*/
    }
    /****************************************************************Plugin Menu****************************************************************/
        public static function access_xchange_active_licence(){
            require_once Accaess_Xchange_PLUGIN_DIR.'inc/settings.php'; /*plugin setting page (admin)*/
        }
        public static function access_xchange_help(){
            require_once Accaess_Xchange_PLUGIN_DIR.'inc/help.php'; /*plugin help page (admin)*/
        }
        public static function access_xchange_log(){
            require_once Accaess_Xchange_PLUGIN_DIR.'inc/logs.php'; /*plugin log page (admin)*/
        }
    /***********************************************************licence key validate************************************************************/
    // public static function activate_licensekey_access_xchange(){
    //     $licensekey=$_POST['key']; 
        
    //     $url='http://box941.temp.domains/~satvikso/project/urvishaDemo/wp-admin/admin-ajax.php?action=license_key_activate&';
    //     $store_code='4Va5QY6PA6cFpWZ';
    //     /*$url='https://www.satvikinfotech.com/wp-admin/admin-ajax.php?action=license_key_activate&';
    //     $store_code='PX2WK3qkR2i878Q';*/
    //     $sku='HPAE01';
    //     $url.='store_code='.$store_code.'&sku='.$sku.'&license_key='.$licensekey;
    //     /*$data=file_get_contents($url);*/
    //    /* $args =  array( 'store_code' => $store_code, 'sku' => $sku, 'license_key' => $licensekey);
    //     $data=wp_remote_get($url,$args);
    //     $response=json_decode($data);*/
    //     /* echo "<pre>";print_r($response);echo "</pre>";exit;*/
    //     $ch = curl_init( $url );
    //    /*Configuring curl options*/
    //    $options = array(
    //    CURLOPT_RETURNTRANSFER => true,
    //    CURLOPT_HTTPHEADER => array("Content-type: application/json")
    //    );
    //    /*Setting curl options*/
    //    curl_setopt_array( $ch, $options );
    //    /*Getting results*/
    //    $result = curl_exec($ch); /*// Getting jSON result string*/
    //    $response=json_decode($result);
    //    // echo "<pre>";print_r($result);echo "</pre>";exit;
    //    $message = array();
    //    if($response->status == 200){
    //         $message['success'] = "<b style='color:darkgreen;'>".$response->message."</b>";
    //         $key=$response->data->the_key;
    //         $expire_date=$response->data->expire_date;
    //         update_option('isof_license_key',$key);
    //         update_option('isof_expire_date',$expire_date);
    //         update_option( 'isof_flag','Y');
    //     }
    //     else if($response->status == 500){
    //         update_option( 'isof_license_key','');
    //         update_option( 'isof_flag','N');
    //         $message['fail'] = "<b style='color:red;'>Invalid license key.</b>";
    //     }
    //     else{
    //         update_option( 'isof_license_key','');
    //         update_option( 'isof_flag','');
    //         $message['fail'] = "<b style='color:red;'>Server not found.</b>";
            
    //     }
    //     echo json_encode($message);
    //     exit;
    // }
    public static function option_access_xchange(){
        $user_option=$_POST['user_option'];
        $memburium_install = get_option('access_xchange_memburium_installed'); 
        if($user_option == 'with_memberium' && $memburium_install == 'YES'){
            $i2sdk_data = get_option('i2sdk');
            update_option('access_xchange_user_option',$user_option);
            if($i2sdk_data['server_verified'] == 1){
                $msg = "<b style='color:darkgreen;'>Your App is verified!!</b>";
            }
            else{
                $msg = "<b style='color:red;'>Please save InfusionSoft credentials to Memburim >> i2sdk</b>";
            }
            echo $msg;
        }
        else if($user_option == 'with_sdk'){
            update_option('access_xchange_user_option',$user_option);
            $msg = "<b style='color:darkgreen;'>Your changes saved!!</b>";
            echo $msg;
        }
        else{
            update_option('access_xchange_user_option','');
            $msg = "<b style='color:red;'>Memburium is not installed!!</b>";
            echo $msg;
        }
        exit;
    }
    public static function is_credantials_access_xchange(){
        $is_cred['is_app_name'] = $_POST['is_app_name']; 
        $is_cred['is_app_key'] = $_POST['is_app_key'];
        $memburium_install = get_option('access_xchange_memburium_installed');
        $user_option = get_option('access_xchange_user_option');
        if($is_cred['is_app_name'] != "" && $is_cred['is_app_key']!=""){
            /*if( ($user_option == "with_sdk" && $memburium_install == "NO") || ($user_option == "with_memberium" && $memburium_install == "NO") ){*/
                require_once Accaess_Xchange_PLUGIN_DIR.'ISlib/isdk.php';
                $app = new iSDK;
                $app_name = $is_cred['is_app_name'];
                $api_key = $is_cred['is_app_key'];
                $connected = 0;
                $connected =  $app->cfgCon($app_name, $api_key);
                $connected2 = $app->dsGetSetting("Contact", "optiontypes");
                if(mb_substr($connected2, 0, 5) == "ERROR"){
                    $connected = 0;
                    update_option('access_xchange_is_data','');
                    echo "<b style='color:red;'>Invalid credentials!!</b>";
                } else{
                    $data = json_encode($is_cred);
                    update_option('access_xchange_is_data',$data);
                    echo "<b style='color:darkgreen;'>Your changes saved!!</b>";
                }   
            /*}
            else if( ($user_option == "with_sdk" && $memburium_install == "YES") )
            {
                $app_name = $is_cred['is_app_name'];
                $api_key = $is_cred['is_app_key'];
                require_once ABSPATH.'wp-content/plugins/i2sdk2/i2sdk2.php';
                global $i2sdk;
                $i2sdk_data = get_option('i2sdk');
                $i2sdk->isdk->configureConnection( $app_name, $api_key );
                $valid_connection = $i2sdk->isdk->verify_Connection();
                $i2sdk->setConfigurationOption( 'server_verified', ( $valid_connection ? 1 : 0 ) );
                if ( ! $valid_connection ) {
                    $connection_failure = $i2sdk->isdk->get_ErrorMessage();
                    echo "<b style='color:red;'>wrong credentials!!</b>";
                }
                else {
                    $connection_failure = '';
                    $i2sdk->setConfigurationOption( 'app_name', strtolower( trim( $app_name ) ) );
                    $i2sdk->setConfigurationOption( 'api_key', trim( $api_key ) );
                    $i2sdk->syncCustomFields();
                }
                if(){}
                $app_name =  $i2sdk_data['app_name'];
                
                $api_key = $i2sdk_data['api_key'];
                $connected = 0;
                $connected =  $i2sdk->isdk->cfgCon($app_name, $api_key);
                $connected2 = $i2sdk->isdk->dsGetSetting("Contact", "optiontypes");
                if(mb_substr($connected2, 0, 5) == "ERROR"){
                    $connected = 0;
                    update_option('access_xchange_is_data','');
                    echo "<b style='color:red;'>wrong credentials!!</b>";
                } else{
                    $data = json_encode($is_cred);
                    update_option('access_xchange_is_data',$data);
                    echo "<b style='color:darkgreen;'>Your changes saved!!</b>";
                }
            }
            else if( ($user_option == "with_memberium" && $memburium_install == "YES")  ){
            }*/
        }else{
            echo "<b style='color:red;'>Fields are required!!</b>";
        }
        
        exit;
    }
}
$access_xchange_infusion = new access_xchange_infusion();
?>