<?php
    
    require ABSPATH.'wp-content/plugins/i2sdk2/i2sdk2.php';
    
    global $i2sdk;
    global $wpdb;

    /*Memburim >> i2sdk >> optional API settings >> api_log=>off*/
    $i2sdk->setConfigurationOption( 'api_log', 0);

    /*get http post parameter*/
    $parentID          = isset( $_REQUEST['parent_id'] ) ? $_REQUEST['parent_id'] : "" ;  
    $user_name         = isset( $_REQUEST['name'] ) ? $_REQUEST['name'] : "" ;
    $user_email        = isset( $_REQUEST['email'] ) ? $_REQUEST['email'] : "" ;
    $child_add_tag     = isset( $_REQUEST['child_tag'] ) ? $_REQUEST['child_tag'] : "" ;
    $parent_add_tag    = isset( $_REQUEST['parent_add_tag'] ) ? $_REQUEST['parent_add_tag'] : "" ;
    $parent_remove_tag = isset( $_REQUEST['parent_remove_tag'] ) ? $_REQUEST['parent_remove_tag'] : "" ;

    $conID = "";      
    $email = "";

    $nvp_feilds_store = $_SERVER['QUERY_STRING'];
    $nvp_store = json_encode($nvp_feilds_store) ;

    /*search user mail exists in IS*/
    $returnFields = array( 'Id', 'Email' );
    $query = array( 'Email' => $user_email );
    $contact = $i2sdk->isdk->dsQuery( "Contact", 20, 0, $query, $returnFields);

    /**************************************************************LOG************************************************************************/
                    /*log entry start*/
                    $directoryName = Accaess_Xchange_PLUGIN_DIR."/Log_IS_WP";
                    if(!is_dir($directoryName)){
                        /*Directory does not exist, so lets create it.*/
                        mkdir($directoryName);
                    }
                    $dateToday = date('Y-m-d');
                    $directoryPath = $directoryName."/".$dateToday.".txt";
                    /*Create datewise log file*/
                    $logfile = fopen($directoryPath, "a");
                    /*append data to log text file*/
                    $start = "*********************************log start*********************************\n\n";
                    fwrite($logfile, $start);
                    
                    $txt = date("d/m/Y H:i:s")."\n\n";
                    fwrite($logfile, $txt);
                    $txt = "http post parameters : \n";
                    fwrite($logfile, $txt);
                    $txt = print_r($_REQUEST,true);
                    fwrite($logfile, $txt);
    /**************************************************************LOG************************************************************************/

    if($user_email != ""){

        if($user_name == ""){
            $user_name = $user_email;
        }
        /*update querystring to database*/
        $table = $wpdb->prefix . "access_xchange_save_http_post";
        $date = date("m-d-Y");
        $msg = "HTTP POST successfully completed!!";
        $sql = "INSERT INTO ".$table." (querystring,status,reason,log_date) VALUES ('".$nvp_store."','success','".$msg."','".$date."')";
        $wpdb->query($sql);

        /*if mail exists*/
        if(count($contact) > 0){

            /************************************************************LOG******************************************************************/
                        $txt = "\nif user in InfusionSoft get contact Array : \n";
                        fwrite($logfile, $txt);
                        $txt = print_r($contact,true);
                        fwrite($logfile, $txt);
            /************************************************************LOG******************************************************************/

            /*find who has child tag if has then remove*/
            $find_child_tag  = array('GroupId' => $child_add_tag);
            $return_tag_list = array('ContactId','GroupId');
            $all_tag_contact = $i2sdk->isdk->dsQuery("ContactGroupAssign",100,0,$find_child_tag,$return_tag_list);
            
            /************************************************************LOG******************************************************************/
                        $txt = "\nAll contact containing child tag : \n";
                        fwrite($logfile, $txt);
                        $txt = print_r($all_tag_contact,true);
                        fwrite($logfile, $txt);
            /************************************************************LOG******************************************************************/

            foreach($all_tag_contact as $key => $tag) 
            {
                /*remove child tag from all contact if any contact has*/
                $contactId = $tag['ContactId'];
                $tag_id = $tag['GroupId'];
                $i2sdk->isdk->grpRemove($tag['ContactId'], $child_add_tag);
            }

            /************************************************************LOG******************************************************************/
                        $txt = "\nChild Tag removed from all contact!\n";
                        fwrite($logfile, $txt);
            /************************************************************LOG******************************************************************/

            if($parentID != ""){
            /*add note to parent contact*/
            $note_description_parent = array( 'Child_ContactId' => $contact[0]['Id'], 'Email' => $contact[0]['Email'] );
            $add_note_parent = array( 'ContactId' => $parentID, 'CreationNotes' => json_encode($note_description_parent), 'ObjectType' => 'Note' );
            $i2sdk->isdk->dsAdd( 'ContactAction', $add_note_parent );
            
            /************************************************************LOG******************************************************************/
                        $txt = "\nNote write to Parent contact in InfusionSoft : ( parentID : ".$parentID." )\n";
                        fwrite($logfile, $txt);
                        $txt = "Note Description : ".print_r($note_description_parent,true);
                        fwrite($logfile, $txt);
            /************************************************************LOG******************************************************************/
            }
            else{
                /********************************************************LOG******************************************************************/
                            $txt = "\nNO parent ID given.\n";
                            fwrite($logfile, $txt);
                /********************************************************LOG******************************************************************/
            }
            
            /*add note to child contact*/
            $note_description_child="";
            if($parentID == ""){
                /*$note_description_child = array('Parent_ContactId' => "no parent");*/
                $note_description_child = "Product Purchased by Third Party".$parentID;
            }
            else{
                /*$note_description_child = array('Parent_ContactId' => $parentID);*/
                $note_description_child = "Product Purchased by Third Party".$parentID;
            }
            $add_note_child = array( 'ContactId' => $contact[0]['Id'], 'CreationNotes' => json_encode($note_description_child), 'ObjectType' => 'Note' );
            $i2sdk->isdk->dsAdd("ContactAction", $add_note_child);

            /************************************************************LOG******************************************************************/
                        $txt = "\nNote write to Child contact in InfusionSoft : ( childID : ".$contact[0]['Id']." )\n";
                        fwrite($logfile, $txt);
                        $txt = "Note Description : ".print_r($note_description_child,true);
                        fwrite($logfile, $txt);
            /************************************************************LOG******************************************************************/

            /*assign child tag to child contact*/
            if($child_add_tag != ""){
                $i2sdk->isdk->grpAssign($contact[0]['Id'], $child_add_tag);
                /********************************************************LOG******************************************************************/
                            $txt = "\nChild Tag Assigned to contactID: ".$contact[0]['Id']." & Tagid : ".$child_add_tag."\n";
                            fwrite($logfile, $txt);
                /********************************************************LOG******************************************************************/
            }else{
                /********************************************************LOG******************************************************************/
                            $txt = "\nNo Child Tag Given.\n";
                            fwrite($logfile, $txt);
                /********************************************************LOG******************************************************************/
            }

            

            if($parent_add_tag != ""){
                $i2sdk->isdk->grpAssign($parentID, $parent_add_tag); /*add tag in parent contact if url has*/

                /**********************************************************LOG****************************************************************/
                        $txt = "\n".$parent_add_tag." Tag Assigned in Parent: ".$parentID."\n";
                        fwrite($logfile, $txt);
                /**********************************************************LOG****************************************************************/

            }
            if($parent_remove_tag != ""){
                $i2sdk->isdk->grpRemove($parentID, $parent_remove_tag); /*remove tag in parent contact if url has*/

                /**********************************************************LOG****************************************************************/
                        $txt = $parent_remove_tag." Tag Removed in Parent: ".$parentID."\n";
                        fwrite($logfile, $txt);
                /**********************************************************LOG****************************************************************/

            }
            
            /*save id and email to variable for sending to http post*/
            $conID = $contact[0]['Id'];      
            $email = $contact[0]['Email'];

            /************************************************************LOG******************************************************************/
                        $txt = "\nUpdated Child contact is ".$conID.": ".$email."\n\n";
                        fwrite($logfile, $txt);
            /************************************************************LOG******************************************************************/
            
        } 
        /*mail not exists*/
        else{
            /*find who has child tag if has then remove*/
            $find_child_tag  = array('GroupId' => $child_add_tag);
            $return_tag_list = array('ContactId','GroupId');
            $all_tag_contact = $i2sdk->isdk->dsQuery("ContactGroupAssign",100,0,$find_child_tag,$return_tag_list);
            
            /************************************************************LOG******************************************************************/
                        $txt = "\nAll contact containing child tag : \n";
                        fwrite($logfile, $txt);
                        $txt = print_r($all_tag_contact,true);
                        fwrite($logfile, $txt);
            /************************************************************LOG******************************************************************/

            foreach($all_tag_contact as $key => $tag) 
            {
                /*remove child tag from all contact if any contact has*/
                $contactId = $tag['ContactId'];
                $tag_id = $tag['GroupId'];
                $i2sdk->isdk->grpRemove($tag['ContactId'], $child_add_tag);
            }

            /************************************************************LOG******************************************************************/
                        $txt = "\nChild Tag removed from all contact!\n";
                        fwrite($logfile, $txt);
            /************************************************************LOG******************************************************************/
            
            /*create child contact*/
            $contactData = array('FirstName' => $user_name, 'Email' => $user_email);
            $conID = $i2sdk->isdk->addCon($contactData);
            $app->optIn($user_email,"Access Exchange IS OrderForm");

            /************************************************************LOG******************************************************************/
                        $txt = "\nNew contact created is : ".$conID."\n";
                        fwrite($logfile, $txt);
            /************************************************************LOG******************************************************************/

            if($child_add_tag != ""){
                /*assign child tag to new contact*/
                $i2sdk->isdk->grpAssign($conID, $child_add_tag);

                /********************************************************LOG******************************************************************/
                            $txt = "child tag Assigned to new contact TAGid: ".$child_add_tag."\n";
                            fwrite($logfile, $txt);
                /********************************************************LOG******************************************************************/
            }else{
                /********************************************************LOG******************************************************************/
                            $txt = "\nNo Child Tag Given.\n";
                            fwrite($logfile, $txt);
                /********************************************************LOG******************************************************************/
            }

            if($parentID != ""){
            /*add note to parent contact*/
            $note_description_parent = array( 'Child_ContactId' => $conID, 'Email' =>$user_email );
            $add_note_parent = array( 'ContactId' => $parentID, 'CreationNotes' => json_encode($note_description_parent), 'ObjectType' => 'Note' );
            $i2sdk->isdk->dsAdd( 'ContactAction', $add_note_parent );
            
            /************************************************************LOG******************************************************************/
                        $txt = "\nNote write to Parent contact in InfusionSoft : ( parentID : ".$parentID." )\n";
                        fwrite($logfile, $txt);
                        $txt = "Note Description : ".print_r($note_description_parent,true);
                        fwrite($logfile, $txt);
            /************************************************************LOG******************************************************************/
            }
            else{
                /********************************************************LOG******************************************************************/
                            $txt = "\nNO parent ID given.\n";
                            fwrite($logfile, $txt);
                /********************************************************LOG******************************************************************/
            }
            
            /*add note to child contact*/
            $note_description_child="";
            if($parentID == ""){
                /*$note_description_child = array('Parent_ContactId' => "no parent");*/
                $note_description_child = "Product Purchased by Third Party".$parentID;
            }
            else{
                /*$note_description_child = array('Parent_ContactId' => $parentID);*/
                $note_description_child = "Product Purchased by Third Party".$parentID;
            }
            $add_note_child = array( 'ContactId' => $conID, 'CreationNotes' => json_encode($note_description_child), 'ObjectType' => 'Note' );
            $i2sdk->isdk->dsAdd("ContactAction", $add_note_child);

            /************************************************************LOG******************************************************************/
                        $txt = "\nNote write to Child contact in InfusionSoft : ( childID : ".$conID." )\n";
                        fwrite($logfile, $txt);
                        $txt = "Note Description : ".print_r($note_description_child,true);
                        fwrite($logfile, $txt);
            /************************************************************LOG******************************************************************/

            if($parent_add_tag != ""){
                $i2sdk->isdk->grpAssign($parentID, $parent_add_tag); /*add tag in parent contact if url has*/

                /**********************************************************LOG****************************************************************/
                        $txt = "\n".$parent_add_tag." Tag Assigned in Parent: ".$parentID."\n";
                        fwrite($logfile, $txt);
                /**********************************************************LOG****************************************************************/

            }
            if($parent_remove_tag != ""){
                $i2sdk->isdk->grpRemove($parentID, $parent_remove_tag); /*remove tag in parent contact if url has*/

                /**********************************************************LOG****************************************************************/
                        $txt = $parent_remove_tag." Tag Removed in Parent: ".$parentID."\n";
                        fwrite($logfile, $txt);
                /**********************************************************LOG****************************************************************/

            }
            /*save id and email to variable for sending to http post*/
            $conID = $conID;      
            $email = $user_email;

            /************************************************************LOG******************************************************************/
                        $txt = "\nAdded Child contact is [ ".$conID." : ".$email." ]\n\n";
                        fwrite($logfile, $txt);
            /************************************************************LOG******************************************************************/

        }

        /**************************************************************LOG********************************************************************/
                        $end =   "*********************************log end*********************************\n\n";
                        fwrite($logfile, $end);
                        
                        fclose($logfile);
                        /*log entry end*/
        /**************************************************************LOG********************************************************************/

        /*run http post for creating user in Wordpress*/
        $memburium_opt = get_option('memberium');
        $authkey = $memburium_opt['settings']['autologin_authkeys'];
        $isof_site_url =  get_site_url();
        if($conID != "" && $email != "")
        {
            /* get url from memburium > settings > http/post  */
            file_get_contents($isof_site_url."/?action=confirmregistration&authkey=".$authkey."&email=".$email."&cid=".$conID);
        }
    }else{
        if($user_name == ""){
            $user_name = $user_email;
        }
        /*update querystring to database*/
        $table = $wpdb->prefix . "access_xchange_save_http_post";
        $date = date("m-d-Y");
        $msg = "name or email are empty in HTTP POST.";
        $sql = "INSERT INTO ".$table." (querystring,status,reason,log_date) VALUES ('".$nvp_store."','fail','".$msg."','".$date."')";
        $wpdb->query($sql);
       
        /**********************************************************LOG****************************************************************/
                $txt = " User Name and Email are blank!\n";
                fwrite($logfile, $txt);
        /**********************************************************LOG****************************************************************/


        /************************************************************LOG******************************************************************/
                        $end =   "*********************************log end*********************************\n\n";
                        fwrite($logfile, $end);
                        
                        fclose($logfile);
                        /*log entry end*/
        /************************************************************LOG******************************************************************/

    }
  
    /*Memburim >> i2sdk >> optional API settings >> api_log=>on*/
    $i2sdk->setConfigurationOption( 'api_log', 1);
?>