jQuery(document).ready(function( $ ) {
    $("#access_xchange_active").click(function(){
        $("#licensekeyform #loaderIS").show();
        var key = $('#activation_key').val();
        $.ajax({
            url: ajax_script.ajaxurl,
            type: 'POST',
            data: {
                'action':'activate_licensekey_access_xchange', 
                'key' : key        
            },
            dataType:'JSON',
            cache: false,
            
            success: function(response){
                /*alert(response);*/
                if (response.success) {
                    $('#licensekeyform img').hide();
                    $("#access_xchange_key_error" ).html(response.success);
                    setTimeout(function(){ location.reload(true); }, 3000);
                } else {
                    $("#access_xchange_key_error" ).html(response.fail);
                    /*setTimeout(function(){ 
                         $("#access_xchange_key_error").hide();
                        location.reload(true);
                         }, 3000);*/
                }
                $("#licensekeyform #loaderIS").hide();
            }
        });
    });
    $("#access_xchange_user_option_btn").click(function(){
        $("#access_xchange_save_user_option #loaderIS").show();
        /* $('#cc_message span').hide();*/
        var user_option = $('#select_access_xchange_option').val();
        $.ajax({
            url: ajax_script.ajaxurl,
            type: 'POST',
            data: {
                'action':'option_access_xchange', 
                'user_option' : user_option        
            },
            cache: false,
            success: function(response){
                $("#access_xchange_save_user_option #loaderIS").hide();
                $('#licensekeyform img').hide();
                $("#access_xchange_user_option_error").html(response);
                /*setTimeout(function(){ $("#access_xchange_user_option_error").hide(); }, 6000);*/
                setTimeout(function(){ location.reload(true); }, 3000);
            }
        });
    });
    $("#access_xchange_is_btn").click(function(){
        $("#access_xchange_is_credentials #loaderIS").show();
        /* $('#cc_message span').hide();*/
        var is_app_name = $('#access_xchange_app_name').val();
        var is_app_key = $('#access_xchange_app_key').val();
        $.ajax({
            url: ajax_script.ajaxurl,
            type: 'POST',
            data: {
                'action':'is_credantials_access_xchange', 
                'is_app_name' : is_app_name,
                'is_app_key' : is_app_key
            },
            cache: false,
            success: function(response){
                $("#access_xchange_is_credentials #loaderIS").hide();
                $('#licensekeyform img').hide();
                $("#access_xchange_check_is_error").html(response);
                /*setTimeout(function(){ $("#access_xchange_check_is_error").hide(); }, 6000);*/
            }
        });
    });
    /*Log Page datatable*/
    $(".access_xchange_logs_table").DataTable({
        "columns": [
            { "data": "Date" },
            { "data": "Http Post" },
            { "data": "Status" },                    
        ],
         "bLengthChange": false,
         "bFilter": true,
         "bInfo": false,
         "bAutoWidth": false,
         "pagingType": "full_numbers",
         "iDisplayLength":20,
         "order" : [[0, 'desc']]
    });
});